//+------------------------------------------------------------------+
//|                                               PrintLastError.mqh |
//|                                                            IgorM |
//|                              https://www.mql5.com/ru/users/igorm |
//+------------------------------------------------------------------+
#property copyright "IgorM"
#property link      "https://www.mql5.com/ru/users/igorm"
#property strict

static int LastError_;
//_______________________________________________________________________
void PrintLastError()
  {
   LastError_ = GetLastError();
   Print(
#ifdef __MQL5__
   ErrorDescriptionMT5(LastError_));
#else #ifdef __MQL4__
   ErrorDescriptionMT4(LastError_));
#endif #endif
  }
//___________________________________________________________________________
string ErrorDescriptionMT4(int error_code)
  {
   string error_string="";
   switch(error_code)
     {
      case   0     :error_string =" ";                                                        break;
      case   1     :error_string =" ,   ";                               break;
      case   2     :error_string =" ";                                                      break;
      case   3     :error_string =" ";                                            break;
      case   4     :error_string ="  ";                                             break;
      case   5     :error_string ="   ";                               break;
      case   6     :error_string ="    ";                                     break;
      case   7     :error_string =" ";                                                 break;
      case   8     :error_string ="  ";                                            break;
      case   9     :error_string =" ,   ";        break;
      case   64    :error_string =" ";                                                 break;
      case   65    :error_string ="  ";                                          break;
      case   128   :error_string ="    ";                             break;
      case   129   :error_string =" ";                                                 break;
      case   130   :error_string =" ";                                                break;
      case   131   :error_string =" ";                                                break;
      case   132   :error_string =" ";                                                      break;
      case   133   :error_string =" ";                                                break;
      case   134   :error_string ="    ";                        break;
      case   135   :error_string =" ";                                                   break;
      case   136   :error_string =" ";                                                           break;
      case   137   :error_string =" ";                                                      break;
      case   138   :error_string =" ";                                                        break;
      case   139   :error_string ="    ";                           break;
      case   140   :error_string ="  ";                                          break;
      case   141   :error_string ="  ";                                            break;
      case   145   :error_string =" ,       ";       break;
      case   146   :error_string ="  ";                                        break;
      case   147   :error_string ="     ";            break;
      case   148   :error_string ="      ,  ";  break;
      case   149   :error_string ="     ,   ";         break;
      case   150   :error_string ="         FIFO";               break;
      case   4000  :error_string =" ";                                                        break;
      case   4001  :error_string ="  ";                                    break;
      case   4002  :error_string ="  -  ";                                    break;
      case   4003  :error_string ="    ";                                      break;
      case   4004  :error_string ="    ";                      break;
      case   4005  :error_string ="      ";                       break;
      case   4006  :error_string ="    ";                               break;
      case   4007  :error_string ="    ";                                   break;
      case   4008  :error_string =" ";                                       break;
      case   4009  :error_string ="   ";                             break;
      case   4010  :error_string ="    ";                                 break;
      case   4011  :error_string ="  ";                                            break;
      case   4012  :error_string ="    ";                                        break;
      case   4013  :error_string ="  ";                                                   break;
      case   4014  :error_string =" ";                                               break;
      case   4015  :error_string =" ";                                              break;
      case   4016  :error_string =" ";                                       break;
      case   4017  :error_string =" DLL  ";                                           break;
      case   4018  :error_string ="  ";                                   break;
      case   4019  :error_string ="  ";                                        break;
      case   4020  :error_string ="     ";                  break;
      case   4021  :error_string ="   ,   ";           break;
      case   4022  :error_string =" ";                                                    break;
      case   4023  :error_string ="   DLL-";                             break;
      case   4024  :error_string =" ";                                                 break;
      case   4025  :error_string =" ";                                                        break;
      case   4026  :error_string =" ";                                                break;
      case   4027  :error_string ="    ";                    break;
      case   4028  :error_string ="      "; break;
      case   4029  :error_string =" ";                                                   break;
      case   4030  :error_string ="  ";                                                break;
      case   4050  :error_string ="   ";                        break;
      case   4051  :error_string ="   ";                           break;
      case   4052  :error_string ="   ";                               break;
      case   4053  :error_string =" ";                                                    break;
      case   4054  :error_string ="  -";                      break;
      case   4055  :error_string ="  ";                               break;
      case   4056  :error_string =" ";                                              break;
      case   4057  :error_string ="   ";                            break;
      case   4058  :error_string ="   ";                               break;
      case   4059  :error_string ="     ";                            break;
      case   4060  :error_string ="  ";                                              break;
      case   4061  :error_string ="  ";                                             break;
      case   4062  :error_string ="   string";                                    break;
      case   4063  :error_string ="   integer";                                   break;
      case   4064  :error_string ="   double";                                    break;
      case   4065  :error_string ="    ";                             break;
      case   4066  :error_string ="     ";            break;
      case   4067  :error_string ="    ";                           break;
      case   4068  :error_string ="  ";                                                  break;
      case   4069  :error_string ="  ";                                          break;
      case   4070  :error_string =" ";                                                  break;
      case   4071  :error_string ="   ";                 break;
      case   4072  :error_string ="   ";                      break;
      case   4073  :error_string ="  ";                                           break;
      case   4074  :error_string ="     ";                         break;
      case   4075  :error_string ="     ";                          break;
      case   4099  :error_string =" ";                                                       break;
      case   4100  :error_string ="    ";                                        break;
      case   4101  :error_string ="  ";                                            break;
      case   4102  :error_string ="   ";                                     break;
      case   4103  :error_string ="  ";                                           break;
      case   4104  :error_string ="    ";                               break;
      case   4105  :error_string ="    ";                                           break;
      case   4106  :error_string =" ";                                                break;
      case   4107  :error_string ="     ";                   break;
      case   4108  :error_string ="  ";                                             break;
      case   4109  :error_string ="  .    \"  \"   ";  break;
      case   4110  :error_string ="    .    ";           break;
      case   4111  :error_string ="    .    ";           break;
      case   4112  :error_string ="    /    ";break;
      case   4200  :error_string ="  ";                                             break;
      case   4201  :error_string ="   ";                            break;
      case   4202  :error_string ="  ";                                              break;
      case   4203  :error_string ="  ";                                           break;
      case   4204  :error_string ="  ";                                                 break;
      case   4205  :error_string ="  ";                                          break;
      case   4206  :error_string ="   ";                                      break;
      case   4207  :error_string ="    ";                                      break;
      case   4210  :error_string ="  ";                                      break;
      case   4211  :error_string ="  ";                                                  break;
      case   4212  :error_string ="   ";                                        break;
      case   4213  :error_string ="  ";                                               break;
      case   4220  :error_string ="  ";                                         break;
      case   4250  :error_string ="  push-";                                  break;
      case   4251  :error_string ="  push-";                                break;
      case   4252  :error_string =" ";                                             break;
      case   4253  :error_string ="    push-";                   break;
      case   4260  :error_string ="  FTP ";                                              break;
      case   4261  :error_string ="  FTP ";                                               break;
      case   4262  :error_string ="    FTP ";                              break;
      case   4263  :error_string ="  FTP  ";                                 break;
      case   4264  :error_string =" FTP       ";           break;
      case   4265  :error_string ="     MQL4\\Files    FTP ";break;
      case   4266  :error_string ="     FTP ";                           break;
      case   5001  :error_string ="   ";                                     break;
      case   5002  :error_string ="  ";                                                break;
      case   5003  :error_string ="   ";                                         break;
      case   5004  :error_string ="  ";                                             break;
      case   5005  :error_string ="    ";                         break;
      case   5006  :error_string ="  ";                                             break;
      case   5007  :error_string ="   (     )";              break;
      case   5008  :error_string ="   (    )";        break;
      case   5009  :error_string ="      FILE_WRITE";                       break;
      case   5010  :error_string ="      FILE_READ";                        break;
      case   5011  :error_string ="      FILE_BIN";                         break;
      case   5012  :error_string ="      FILE_TXT";                         break;
      case   5013  :error_string ="      FILE_TXT  FILE_CSV";            break;
      case   5014  :error_string ="      FILE_CSV";                         break;
      case   5015  :error_string ="  ";                                               break;
      case   5016  :error_string ="  ";                                               break;
      case   5017  :error_string ="       ";              break;
      case   5018  :error_string ="   (  -TXT,   -BIN)"; break;
      case   5019  :error_string ="  ";                                         break;
      case   5020  :error_string ="  ";                                                break;
      case   5021  :error_string ="    ";                                    break;
      case   5022  :error_string ="  ";                                           break;
      case   5023  :error_string ="  ";                                          break;
      case   5024  :error_string ="    ";                            break;
      case   5025  :error_string ="  ";                                        break;
      case   5026  :error_string ="  ";                                         break;
      case   5027  :error_string ="   ";                                  break;
      case   5028  :error_string ="   ";                                   break;
      case   5029  :error_string ="     ";                break;
      case   5200  :error_string ="URL   ";                                            break;
      case   5201  :error_string ="     URL";                          break;
      case   5202  :error_string ="   ";                                 break;
      case   5203  :error_string ="    HTTP ";                       break;
      default      :error_string =",  ";                                  break;
     }
   return("  "+IntegerToString(error_code)+" : "+error_string);
  }
//___________________________________________________________________________
string ErrorDescriptionMT5(int error_code)
  {
   string error_string="";
   switch(error_code)
     {
      case    0       :error_string ="  ";                                                                                    break;
      case    4001    :error_string ="  ";                                                                                 break;
      case    4002    :error_string ="       ";                                        break;
      case    4003    :error_string ="     ";                                                               break;
      case    4004    :error_string ="     ";                                                          break;
      case    4005    :error_string ="    /   /     / ";  break;
      case    4006    :error_string ="  ,       ";                 break;
      case    4007    :error_string ="          ";         break;
      case    4008    :error_string ="    ";                                                              break;
      case    4009    :error_string =" ";                                                                                   break;
      case    4010    :error_string ="   / ";                                                                      break;
      case    4011    :error_string ="    2 ";                                                            break;
      case    4012    :error_string =" ";                                                                                           break;
      case    4013    :error_string ="  ";                                                                                       break;
      case    4014    :error_string ="     ";                                                                     break;
      case    4015    :error_string ="     ";                                                        break;
      case    4016    :error_string ="     EX5  ";                                                                         break;
      case    4017    :error_string ="      16 MB";                                                           break;
      case    4018    :error_string ="   63 ";                                                                              break;
      case    4019    :error_string ="     ";                                                  break;
      case    4101    :error_string ="  ";                                                                               break;
      case    4102    :error_string ="  ";                                                                                            break;
      case    4103    :error_string ="  ";                                                                                              break;
      case    4104    :error_string ="   ,     ";                                                     break;
      case    4105    :error_string ="  ";                                                                                       break;
      case    4106    :error_string ="       ";                                                            break;
      case    4107    :error_string ="        ";                                                 break;
      case    4108    :error_string ="   ";                                                                                   break;
      case    4109    :error_string ="   ";                                                                      break;
      case    4110    :error_string ="   ";                                                                                 break;
      case    4111    :error_string ="   ";                                                                                   break;
      case    4112    :error_string ="   ";                                                                                 break;
      case    4113    :error_string =",   ,  ";                                                           break;
      case    4114    :error_string ="     ";                                                                    break;
      case    4115    :error_string ="     ";                                                                      break;
      case    4116    :error_string ="     ";                                                                      break;
      case    4201    :error_string ="     ";                                                                      break;
      case    4202    :error_string ="   ";                                                                                  break;
      case    4203    :error_string ="    ";                                                         break;
      case    4204    :error_string ="  ,  ";                                                            break;
      case    4205    :error_string ="  ,  ";                                                            break;
      case    4301    :error_string =" ";                                                                                            break;
      case    4302    :error_string ="    MarketWatch";                                                                                break;
      case    4303    :error_string ="   ";                                                                      break;
      case    4304    :error_string ="    (  )";                                                              break;
      case    4305    :error_string ="      MarketWatch";                                                          break;
      case    4401    :error_string ="   ";                                                                              break;
      case    4402    :error_string ="   ";                                                                      break;
      case    4403    :error_string ="    ";                                                                          break;
      case    4404    :error_string ="     ";                                               break;
      case    4405    :error_string ="    ";                                                                         break;
      case    4407    :error_string ="        ";                                          break;
      case    4501    :error_string ="     ";                                                        break;
      case    4502    :error_string ="        ";                                     break;
      case    4503    :error_string ="    ";                                                                     break;
      case    4504    :error_string ="         ";                                       break;
      case    4505    :error_string ="       ";                                                  break;
      case    4510    :error_string ="   ";                                                                                   break;
      case    4511    :error_string ="   ";                                                                                 break;
      case    4512    :error_string ="   ";                                                                    break;
      case    4513    :error_string ="   ";                                                                    break;
      case    4514    :error_string ="     ftp";                                                                              break;
      case    4515    :error_string ="   ";                                                                              break;
      case    4516    :error_string ="        SendNotification()     NULL";    break;
      case    4517    :error_string ="     (  ID    )";                        break;
      case    4518    :error_string ="   ";                                                                           break;
      case    4519    :error_string ="  FTP ";                                                                                          break;
      case    4520    :error_string ="  FTP ";                                                                                           break;
      case    4521    :error_string ="     MQL5\\Files    FTP ";                                            break;
      case    4522    :error_string ="    FTP ";                                                                          break;
      case    4523    :error_string =" FTP       ";                                                       break;
      case    4524    :error_string ="  FTP  ";                                                                             break;
      case    4601    :error_string ="     ";                                                    break;
      case    4602    :error_string ="    ";                                                                  break;
      case    4603    :error_string ="    ";                                                 break;
      case    4701    :error_string ="   ";                                                                        break;
      case    4751    :error_string ="   ";                                                                     break;
      case    4752    :error_string ="   ";                                                                               break;
      case    4753    :error_string ="  ";                                                                                            break;
      case    4754    :error_string ="  ";                                                                                               break;
      case    4755    :error_string ="  ";                                                                                             break;
      case    4756    :error_string ="    ";                                                                          break;
      case    4758    :error_string ="      ";                                                               break;
      case    4801    :error_string =" ";                                                                                            break;
      case    4802    :error_string ="    ";                                                                                break;
      case    4803    :error_string ="    ";                                                                 break;
      case    4804    :error_string ="       ";                                                         break;
      case    4805    :error_string ="   ";                                                                              break;
      case    4806    :error_string ="   ";                                                                                 break;
      case    4807    :error_string ="  ";                                                                                    break;
      case    4808    :error_string ="     ";                                                    break;
      case    4809    :error_string ="    ";                                                                 break;
      case    4810    :error_string ="        ";                                      break;
      case    4811    :error_string ="       ";                                                  break;
      case    4812    :error_string ="    ";                                                          break;
      case    4901    :error_string ="     ";                                                                             break;
      case    4902    :error_string ="     ";                                                                               break;
      case    4903    :error_string ="      ";                                                                     break;
      case    4904    :error_string ="        ";                                                     break;
      case    5001    :error_string ="      64 ";                                                            break;
      case    5002    :error_string ="  ";                                                                                        break;
      case    5003    :error_string ="   ";                                                                                     break;
      case    5004    :error_string ="  ";                                                                                         break;
      case    5005    :error_string ="    ";                                                                           break;
      case    5006    :error_string ="  ";                                                                                         break;
      case    5007    :error_string ="      ,    ";                                                break;
      case    5008    :error_string ="  ";                                                                                         break;
      case    5009    :error_string ="     ";                                                                            break;
      case    5010    :error_string ="     ";                                                                            break;
      case    5011    :error_string ="     ";                                                                          break;
      case    5012    :error_string ="     ";                                                                         break;
      case    5013    :error_string ="       CSV";                                                                 break;
      case    5014    :error_string ="     CSV";                                                                               break;
      case    5015    :error_string ="  ";                                                                                           break;
      case    5016    :error_string ="    ,      ";                                            break;
      case    5017    :error_string ="      ,    ";                                   break;
      case    5018    :error_string ="  ,  ";                                                                                     break;
      case    5019    :error_string ="  ";                                                                                            break;
      case    5020    :error_string ="    ";                                                                                  break;
      case    5021    :error_string ="  ";                                                                                      break;
      case    5022    :error_string ="  ";                                                                                      break;
      case    5023    :error_string =" ,   ";                                                                                     break;
      case    5024    :error_string ="    ";                                                                              break;
      case    5025    :error_string ="    (,          )";break;
      case    5026    :error_string ="     ";                                                                             break;
      case    5027    :error_string ="       CSV- (FileReadString, FileReadNumber, FileReadDatetime, FileReadBool),     ";break;
      case    5030    :error_string ="   ";                                                                                             break;
      case    5031    :error_string ="   ";                                                                                       break;
      case    5032    :error_string ="   ";                                                                                      break;
      case    5033    :error_string ="    ";                                                                           break;
      case    5034    :error_string ="   ";                                                                                break;
      case    5035    :error_string ="  ,  ";                                                                            break;
      case    5036    :error_string ="  , ,  ULONG_MAX";                                                                  break;
      case    5037    :error_string ="  ";                                                                                    break;
      case    5038    :error_string ="  ,  ";                                                               break;
      case    5039    :error_string =" ,   ";                                                               break;
      case    5040    :error_string ="   string";                                                                              break;
      case    5041    :error_string ="   ";                                                                                   break;
      case    5042    :error_string ="    0,  ";                                                               break;
      case    5043    :error_string ="      ";                                                               break;
      case    5044    :error_string ="  ";                                                                                     break;
      case    5050    :error_string ="  .        ,      ";break;
      case    5051    :error_string ="    AS_SERIES,    ";                                           break;
      case    5052    :error_string ="  ,     ";                                              break;
      case    5053    :error_string ="  ";                                                                                          break;
      case    5054    :error_string ="   ";                                                                                   break;
      case    5055    :error_string ="   ";                                                                                 break;
      case    5056    :error_string ="    ";                                                                          break;
      case    5057    :error_string ="    double";                                                                                break;
      case    5058    :error_string ="    float";                                                                                 break;
      case    5059    :error_string ="    long";                                                                                  break;
      case    5060    :error_string ="    int";                                                                                   break;
      case    5061    :error_string ="    short";                                                                                 break;
      case    5062    :error_string ="    char";                                                                                  break;
      case    5063    :error_string ="    string";                                                                                break;
      case    5100    :error_string =" OpenCL     ";                                                         break;
      case    5101    :error_string ="    OpenCL";                                                                       break;
      case    5102    :error_string ="  OpenCL";                                                                                     break;
      case    5103    :error_string ="    OpenCL";                                                                          break;
      case    5104    :error_string ="     OpenCL";                                                                   break;
      case    5105    :error_string ="    OpenCL";                                                                        break;
      case    5106    :error_string ="     ( OpenCL)";                                                               break;
      case    5107    :error_string ="   -   OpenCL";                                                                   break;
      case    5108    :error_string ="      OpenCL (    OpenCL)";                            break;
      case    5109    :error_string ="   OpenCL";                                                                            break;
      case    5110    :error_string ="   OpenCL";                                                                                 break;
      case    5111    :error_string ="    OpenCL";                                                                             break;
      case    5112    :error_string ="   OpenCL";                                                                                 break;
      case    5113    :error_string ="   OpenCL ";                                                                  break;
      case    5114    :error_string ="  OpenCL ";                                                                               break;
      case    5200    :error_string ="URL   ";                                                                                        break;
      case    5201    :error_string ="     URL";                                                                      break;
      case    5202    :error_string ="   ";                                                                             break;
      case    5203    :error_string ="    HTTP ";                                                                   break;
      case    5270    :error_string ="     ";                                                                       break;
      case    5271    :error_string ="    ( 128)";                                                                  break;
      case    5272    :error_string ="         ,   ";       break;
      case    5273    :error_string =" /   ";                                                                    break;
      case    5274    :error_string ="    (TLS Handshake)";                                                    break;
      case    5300    :error_string ="    ";                                                                    break;
      case    5301    :error_string ="   .           ,   ";break;
      case    5302    :error_string ="     .       32     0";break;
      case    5303    :error_string ="     .     128    Custom,  ,     0";break;
      case    5304    :error_string ="      ";                                                         break;
      case    5305    :error_string ="  ,     ";                                         break;
      case    5306    :error_string ="   ,     (Market Watch)";                              break;
      case    5307    :error_string ="   ";                                                               break;
      case    5308    :error_string ="      ";                                           break;
      case    5309    :error_string ="        ";                           break;
      case    5310    :error_string ="     ";                                                                      break;
      default         :error_string="    ,  ";                                                       break;
     }
   return("  "+IntegerToString(error_code)+" : "+error_string);
  }
//___________________________________________________________________________
